#ifndef SSO_GSSAPI_H
#define SSO_GSSAPI_H

#ifdef __cplusplus
extern "C"{
#endif

#include <time.h>

enum TYPE_KIMSSO_TOKEN {
    TYPE_TOKEN_GSSAPI = 0,
    TYPE_TOKEN_HTTP,
    TYPE_TOKEN_EXT
};

enum KIM_SSO_CODE {
    KIM_SSO_SUCCESS = 0,
    KIM_SSO_INVALID_PARAM,
    KIM_SSO_INVALID_USER,
    KIM_SSO_NO_REALM,
    KIM_SSO_AUTH_FAILED,
    KIM_SSO_NETWORK_ERR
};

typedef struct _kim_user_token
{
    char *user;
    int type;
    char *token;
    int token_len;
    time_t create_time;
} kim_user_token;

int get_user_token(int type, const char* service, kim_user_token **tok);

int get_gssapi_token(const char* service, kim_user_token *tok);

int get_http_token(const char* server, kim_user_token *token);

int connect_http_server(const char* server, kim_user_token *token);

void free_user_token(kim_user_token *user_tok);

#ifdef __cplusplus
}
#endif
#endif // SSO_GSSAPI_H
